"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var sharp_1 = __importDefault(require("sharp"));
var path_1 = __importDefault(require("path"));
var app_root_path_1 = __importDefault(require("app-root-path"));
var utils_1 = require("./utils");
var ImageAugmentation = /** @class */ (function () {
    function ImageAugmentation() {
        var _this = this;
        this.__ctr = 1;
        this.__amount = Infinity;
        this.multiple = false;
        this.__utils = function () {
            var incCtr = function () { _this.__ctr++; };
            var decCtr = function () { _this.__ctr--; };
            var getCtr = function () { return _this.__ctr; };
            var setCtr = function (a) { _this.__ctr = a; };
            var setAmount = function (a) { _this.__amount = a; };
            var getAmount = function () { return _this.__amount; };
            return {
                incCtr: incCtr, getCtr: getCtr, decCtr: decCtr, setAmount: setAmount, getAmount: getAmount, setCtr: setCtr
            };
        };
        this.templateFunc = function (func, probability, image, output) { return __awaiter(_this, void 0, void 0, function () {
            var isDir, imagename, files, i, imagename, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 12, , 13]);
                        if (!this.multiple) {
                            this.__utils().setCtr(1);
                            this.__utils().setAmount(Infinity);
                        }
                        else {
                            process.stdout.write('\rGenerating: ' + ((this.__utils().getCtr() - 1) / this.__utils().getAmount() * 100).toFixed(0) + "%");
                        }
                        if (probability > 1)
                            throw Error("Probability cannot be greater than 1.");
                        else if (probability < 0)
                            throw Error("Probability cannot be less than 0.");
                        if (this.__utils().getAmount() < this.__utils().getCtr())
                            return [2 /*return*/];
                        utils_1.createDir(output);
                        isDir = void 0;
                        if (!(typeof image === 'string')) return [3 /*break*/, 2];
                        return [4 /*yield*/, utils_1.checkIfDir(image)];
                    case 1:
                        isDir = _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        isDir = false;
                        _a.label = 3;
                    case 3:
                        if (!!isDir) return [3 /*break*/, 6];
                        if (!utils_1.probabilityFunc(probability)) return [3 /*break*/, 5];
                        imagename = this.__utils().getCtr().toString() + '.jpg';
                        this.__utils().incCtr();
                        return [4 /*yield*/, func(image, imagename)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [3 /*break*/, 11];
                    case 6: return [4 /*yield*/, utils_1.allImagesInDir(image)];
                    case 7:
                        files = _a.sent();
                        if (files.length === 0)
                            throw ("\nNo images were found.");
                        i = 0;
                        _a.label = 8;
                    case 8:
                        if (!(i < files.length)) return [3 /*break*/, 11];
                        if (this.__utils().getAmount() < this.__utils().getCtr())
                            return [2 /*return*/];
                        if (!utils_1.probabilityFunc(probability)) return [3 /*break*/, 10];
                        imagename = this.__utils().getCtr().toString() + '.jpg';
                        this.__utils().incCtr();
                        return [4 /*yield*/, func(files[i], imagename)];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10:
                        i++;
                        return [3 /*break*/, 8];
                    case 11: return [3 /*break*/, 13];
                    case 12:
                        e_1 = _a.sent();
                        this.__utils().setAmount(-1);
                        throw (e_1);
                    case 13: return [2 /*return*/];
                }
            });
        }); };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The grey images will be saved to the output directory.
         */
        this.makeGrey = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_2;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().greyscale().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_2 = _d.sent();
                            console.log(e_2);
                            throw (e_2);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring
         * @param {number} rotationDegree The degree of rotation.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The rotated images will be saved to the output directory.
         * @example Rotation degree 90 will rotate the image right.
         */
        this.rotate = function (_a) {
            var rotationDegree = _a.rotationDegree, _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_3;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().rotate(rotationDegree).toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_3 = _d.sent();
                            console.log(e_3);
                            throw (e_3);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {number} rotationDegree The degree of rotation.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The rotated images will be saved to the output directory.
         * @example Rotation degree 90 will rotate the image right.
         */
        this.rotateRight = function (_a) {
            var rotationDegree = _a.rotationDegree, _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_4;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().rotate(rotationDegree).toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_4 = _d.sent();
                            console.log(e_4);
                            throw (e_4);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {number} rotationDegree The degree of rotation.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The rotated images will be saved to the output directory.
         * @example Rotation degree 90 will rotate the image left.
         */
        this.rotateLeft = function (_a) {
            var rotationDegree = _a.rotationDegree, _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_5;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().rotate(rotationDegree - 180).toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_5 = _d.sent();
                            console.log(e_5);
                            throw (e_5);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {"left" | "top" | "right" | "bottom"} padding The direction of where the padding should be applied.
         * @param {number} amount The amount of padding.
         * @param {{r: number, g: number, b: number}} background The color of the padded pixels.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The modified images will be saved to the output directory.
         * @example padding="top", amount=10, background={r: 255, g: 255, b: 255} will add 10 white pixels to the top of the image.
         */
        this.addPadding = function (_a) {
            var padding = _a.padding, amount = _a.amount, background = _a.background, _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var extendobj_1, e_6;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            extendobj_1 = { bottom: 0, top: 0, left: 0, right: 0, background: { r: 0, g: 0, b: 0, alpha: 1 } };
                            if (padding === "bottom" || padding === "right" || padding === "top" || padding === "left")
                                extendobj_1[padding] = amount;
                            extendobj_1.background = __assign(__assign({}, background), { alpha: 1 });
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().extend(extendobj_1).toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_6 = _d.sent();
                            console.log(e_6);
                            throw (e_6);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The flipped images will be saved to the output directory.
         */
        this.flipX = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_7;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).flop().removeAlpha().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_7 = _d.sent();
                            console.log(e_7);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The flipped images will be saved to the output directory.
         */
        this.flipY = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_8;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).flip().removeAlpha().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_8 = _d.sent();
                            console.log(e_8);
                            throw (e_8);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} width The new width of the image.
         * @param {number} height The new height of the image.
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The resized images will be saved to the output directory.
         */
        this.resize = function (_a) {
            var width = _a.width, height = _a.height, _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_9;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).resize({ width: width, height: height, fit: 'fill' }).removeAlpha().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_9 = _d.sent();
                            console.log(e_9);
                            throw (e_9);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The sharpened images will be saved to the output directory.
         */
        this.sharpen = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_10;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().sharpen().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_10 = _d.sent();
                            console.log(e_10);
                            throw (e_10);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The blurred images will be saved to the output directory.
         */
        this.blur = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_11;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().blur().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_11 = _d.sent();
                            console.log(e_11);
                            throw (e_11);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {number} [probability = 0.5] The probability of the function occuring.
         * @param {string | Buffer} image The path or the Buffer of the image. If the given path is a directory, all images in that directory will be augmenated.
         * @param {string} [output = "./output"] The output folder in the current directory.
         * @description Select a probability and the image or directory. The negated images will be saved to the output directory.
         */
        this.negate = function (_a) {
            var _b = _a.probability, probability = _b === void 0 ? 0.5 : _b, image = _a.image, _c = _a.output, output = _c === void 0 ? "./output" : _c;
            return __awaiter(_this, void 0, void 0, function () {
                var e_12;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.templateFunc(function (image, imagename) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, sharp_1.default(image).removeAlpha().negate().toFile(path_1.default.join(app_root_path_1.default.path, output, imagename))];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                }); }); }, probability, image, output)];
                        case 1:
                            _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            e_12 = _d.sent();
                            console.log(e_12);
                            throw (e_12);
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {async () => {}} execute The function in which the member functions of the class should be called.
         * @param {string} outputNumber The number of images desired.
         * @description Select the member functions and the amount of images desired. The functions will be executed until there is the output is equal to the amount of desired images.
         */
        this.executeMultiple = function (_a) {
            var execute = _a.execute, outputNumber = _a.outputNumber;
            return __awaiter(_this, void 0, void 0, function () {
                var e_13;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 4, , 5]);
                            this.__utils().setAmount(outputNumber);
                            this.__utils().setCtr(1);
                            this.multiple = true;
                            _b.label = 1;
                        case 1:
                            if (!(this.__utils().getCtr() <= this.__utils().getAmount())) return [3 /*break*/, 3];
                            return [4 /*yield*/, execute()];
                        case 2:
                            _b.sent();
                            return [3 /*break*/, 1];
                        case 3:
                            process.stdout.write('\n');
                            this.multiple = false;
                            return [3 /*break*/, 5];
                        case 4:
                            e_13 = _b.sent();
                            this.multiple = false;
                            console.log(e_13);
                            throw (e_13);
                        case 5: return [2 /*return*/];
                    }
                });
            });
        };
    }
    return ImageAugmentation;
}());
exports.ImageAugmentation = ImageAugmentation;
